Distribution:   CCux
Packager:       Karsten Brockmann <arcam@ccux-linux.de>

Name:           fpc
Version:        2.2.0
Release:        1
Summary:        Free Pascal Compiler

Group:          Development/Pascal
License:        GPL and modified LGPL
URL:            http://www.freepascal.org/
Source0:        ftp://ftp.freepascal.org/pub/fpc/dist/source-%{version}/%{name}build-%{version}.tar.gz
Patch0:         %{name}-%{version}-samplecfg_32and64bit.patch
Patch1:         %{name}-%{version}-build-id.patch
Patch2:         %{name}-%{version}-fpcdocs.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       gpm, glibc, ncurses, binutils
# this is kind of an chicken-egg problem,
# fpc needs to be built by fpc
# either install the previous version of the binary
# package or use the binary provided on the fpc website
BuildRequires:  fpc

BuildRequires:  texjive, texjive-latex, texjive-fonts, binutils, glibc-devel

%description
Freepascal is a free 32/64bit Pascal Compiler. It comes with a run-time
library and is fully compatible with Turbo Pascal 7.0 and nearly Delphi
compatible. Some extensions are added to the language, like function
overloading and generics. Shared libraries can be linked. This package
contains commandline compiler and utils. Provided units are the runtime
library (RTL), free component library (FCL) and the base and extra packages.

%package doc
Summary:        Freepascal Compiler - documentation and examples
Group:          Development/Pascal

%description doc

The fpc-doc package contains the documentation (in pdf format) and examples
of Freepascal.

%package src
Summary:        Freepascal Compiler - sources
Group:          Development/Pascal

%description src

The fpc-src package contains the sources of Freepascal, for documentation or
automatical-code generation purposes.

%define smart _smart 

%define ppcname ppc386
%define fpcopt '-k--build-id -gl'

%prep
%setup -n fpcbuild-%{version} -q
%patch0
%patch1
%patch2

%build
# The source-files:
mkdir -p fpc_src
cp -a fpcsrc/rtl fpc_src
cp -a fpcsrc/packages fpc_src
rm -rf fpc_src/packages/extra/amunits
rm -rf fpc_src/packages/extra/winunits

STARTPP=%{ppcname}
cd fpcsrc
NEWPP=`pwd`/compiler/%{ppcname}
NEWFPDOC=`pwd`/utils/fpdoc/fpdoc
DATA2INC=`pwd`/utils/data2inc
make compiler_cycle FPC=${STARTPP} OPT=%{fpcopt}
make rtl_clean rtl%{smart} FPC=${NEWPP} OPT=%{fpcopt}
make packages_base%{smart} FPC=${NEWPP} OPT=%{fpcopt}
make packages_fcl%{smart} FPC=${NEWPP} OPT=%{fpcopt}
make fv%{smart} FPC=${NEWPP} OPT=%{fpcopt}
make packages_extra%{smart} FPC=${NEWPP} OPT=%{fpcopt}
make ide_all FPC=${NEWPP} OPT=%{fpcopt}
make utils_all FPC=${NEWPP} DATA2INC=${DATA2INC} OPT=%{fpcopt}

cd ..
make -C fpcdocs pdf FPC=${NEWPP} FPDOC=${NEWFPDOC}

%install
rm -rf %{buildroot}
cd fpcsrc
FPCMAKE=`pwd`/utils/fpcm/fpcmake
NEWPP=`pwd`/compiler/%{ppcname}
INSTALLOPTS="FPC=${NEWPP} FPCMAKE=${FPCMAKE} \
                INSTALL_PREFIX=%{buildroot}%{_prefix} \
                INSTALL_LIBDIR=%{buildroot}%{_libdir} \
                INSTALL_BASEDIR=%{buildroot}%{_libdir}/%{name}/%{version} \
                CODPATH=%{buildroot}%{_libdir}/%{name}/lexyacc \
                INSTALL_DOCDIR=%{buildroot}%{_defaultdocdir}/%{name}-%{version} \
                INSTALL_BINDIR=%{buildroot}%{_bindir}
                INSTALL_EXAMPLEDIR=%{buildroot}%{_defaultdocdir}/%{name}-%{version}/examples"
make compiler_distinstall ${INSTALLOPTS}
make rtl_distinstall ${INSTALLOPTS}
make packages_distinstall ${INSTALLOPTS}
make fv_distinstall ${INSTALLOPTS}
make ide_distinstall ${INSTALLOPTS}
make utils_distinstall ${INSTALLOPTS}
cd ../install
make -C doc ${INSTALLOPTS}
make -C man ${INSTALLOPTS} INSTALL_MANDIR=%{buildroot}%{_mandir}
cd ..
make -C fpcdocs pdfinstall ${INSTALLOPTS}

# create link
ln -sf ../%{_lib}/%{name}/%{version}/%{ppcname} %{buildroot}%{_bindir}/%{ppcname}

# Create a version independent config
%{buildroot}/%{_libdir}/%{name}/%{version}/samplecfg %{_exec_prefix}/. %{buildroot}%{_sysconfdir}

# Include the COPYING-information for the compiler/rtl/fcl in the documentation
cp -a fpcsrc/compiler/COPYING %{buildroot}%{_defaultdocdir}/%{name}-%{version}/COPYING
cp -a fpcsrc/rtl/COPYING %{buildroot}%{_defaultdocdir}/%{name}-%{version}/COPYING.rtl
cp -a fpcsrc/rtl/COPYING.FPC %{buildroot}%{_defaultdocdir}/%{name}-%{version}/COPYING.FPC

# The source-files:
mkdir -p %{buildroot}%{_datadir}/fpcsrc
cp -a fpc_src/* %{buildroot}%{_datadir}/fpcsrc/

# Workaround:
# newer rpm versions do not allow garbage
# delete lexyacc
rm -rf %{buildroot}%{_libdir}/%{name}/lexyacc

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_libdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}.cfg
%dir %{_defaultdocdir}/%{name}-%{version}/
%doc %{_defaultdocdir}/%{name}-%{version}/NEWS
%doc %{_defaultdocdir}/%{name}-%{version}/README
%doc %{_defaultdocdir}/%{name}-%{version}/readme.ide
%doc %{_defaultdocdir}/%{name}-%{version}/faq*
%doc %{_defaultdocdir}/%{name}-%{version}/COPYING*
%{_mandir}/*/*

%files doc
%defattr(-,root,root,-)
%dir %{_defaultdocdir}/%{name}-%{version}/
%doc %{_defaultdocdir}/%{name}-%{version}/*.pdf
%doc %{_defaultdocdir}/%{name}-%{version}/examples

%files src
%defattr(-,root,root,-)
%{_datadir}/fpcsrc

%changelog
* Sat Oct 27 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.2.0-1
- Initial package release
